/**********************************************************************
 *                                                                    *
 *                          Drunk3nships                              *
 *                           version 1                                *
 *                                                                    *
 *                 A simple ascii battleship game!                    *
 *             gcc -o battl3ship battl3ship.c for compile.            *
 *      The rules are inside the game, just type 1 on game start!     *
 *                                                                    *
 *       This game is released as open source under GPL license       *
 *        http://creativecommons.org/licenses/GPL/2.0/deed.it         *
 *             http://www.gnu.org/licenses/gpl-2.0.txt                *
 *                                                                    *
 *   This game is provided without warranty, use it at your own risk! *
 *                                                                    *
 *                     pix3lworkshop.altervista.org                   *
 *                                                                    *
 *********************************************************************/

#include <stdio.h>
#include <stdlib.h>

#define SIZE 10
#define MAX_SHIPS 5

int map[SIZE][SIZE], i, j, choice, x, y, beer=99, ships;
char playfield[SIZE][SIZE];

int shoot();

void clrscr()
{
  //this will be replaced
  for (i = 0; i <= 5; i++)
   printf("\n");
}

int controls()
{
	printf("\nType [1] Shoot! [2] Stats [3] Exit - Make your choice: ");
	scanf("%d", &choice);
     switch (choice) 
     {
      case 1:
       if(choice<=1)
        shoot();
       return 0;
      case 2:
       if(choice<=2)
        printf("\nThere are %d ships in the sea\n", ships);
       return 0;
      case 3:
       if(choice<=3)
        printf("\nThanks for playing.\n");
       break;
      default:
       printf("Invalid choice, look better!\n");
       return 0;
       controls();
     }
}

int coord()
{
	printf("Insert the X ordinate: ");
	scanf("%d", &x);

	printf("Insert the Y ordinate: ");
	scanf("%d", &y);
	//printf("[Debug] %d %d %d\n", x, y, map[x][y]);
}

int shoot()
{
    coord();
      if(map[x][y] == 1)
       {
       	clrscr();
       	ships--;
        printf("Ship of fools! %d ships left!\n\n", ships);
        printf("     _|_                   .  ;  ; .|_    \n"
               "    ``|`                    \'  .. \'`|``   \n"
               "   ```|``                  =- {  } -=```  \n"
               "   `__!__    )\'               .\"\". _!__`  \n"
               "   :     := },;            .  ;  ; .   :  \n"
               "   '.   .'                       \'.   .\'  \n"
               " ~-=~~-=~~-=~~-=~~-=~~-=~~-=~~-=~~-=~~-=~~\n");
        map[x][y] = 2;
        playfield[x][y] = 'x';
        getchar();
        getchar();
       	clrscr();
       }
      else if(map[x][y] == 2)
       {
       	printf("You have alredy shot there!\n");
       	shoot();
       }
      else
       {
       	ships--;
       	beer--;
       	playfield[x][y] = '*';
       	printf("%d bottle of beer on the wall. %d ships left!\n", beer, ships);
       }
}

int draw()
{
	printf("    0   1   2   3   4   5   6   7   8   9 ");
	for(i=0; i<SIZE; i++)
     {
      printf("\n  +---+---+---+---+---+---+---+---+---+---+\n");
      printf("%d + ", i);
      for(j=0; j<SIZE; j++)
       {
       	//printf("%d", map[i][j]); //Debug map!
	    printf("%c", playfield[i][j]);
	    printf(" | ");
	   }
     }
    printf("\n  +---+---+---+---+---+---+---+---+---+---+\n");
}

int help()
{
	clrscr();
	printf("How to play:\n"
	       "When the game starts you see a map with coordinates and a menu with some actions.\n"
	       "You can select an action by pressing the associated number.\n"
	       "The rules are simple, in order to defate the royal navy you have to say your pirates where to shoot the cannon balls.\n"
	       "You can do it by selecting a coordinates, the horizzontal series are intended Y, the vertical ones are X!"
	       "The ships are placed randomly in the sea and you have 99 tries for catching them, represented by 99 bottles of beer.\n"
	       "The game will end when you decide to stop or or when you run out of beer pushing your pirates mutiny!!!\n"
	       "Place where you already shot will be marked with a * or X if a ship was there.\n"
	       "This game need a terminal of 25 rows for a good gaming expirience.\n\n"
	       "Have fun! :D\n\nPix3l");
    getchar();
    getchar();
}

int main()
{
	//erase our playfield
    for(i=0; i<SIZE; i++)
     for(j=0; j<SIZE; j++)
      {
       map[i][j] = 0;
       playfield[i][j]='~';
      }
    
    srand(time(NULL));
    
    while (ships<MAX_SHIPS)
    {
     map[rand() % 20][rand() % 20]=1;
     ships++;
    }
    
       printf("\n                _==|\n"
              "             _==|   )__)  |\n"
              "               )_)  )___) ))\n"
              "              )___) )____))_)\n"
              "         _    )____)_____))__)\\ \n"
              "          \\--__|____ |___|___- ---\n"
              "  ^^^^^^^^^\\   oo oo oo oo     /~~^^^^^^^\n"
              "    ~^^^^ ~~~~^^~~~~^^~~^^~~~~~\n"
              "      ~~^^      ~^^~     ~^~ ~^ ~^\n"
              "           ~^~~        ~~~^^~\n\n"
              "                 Drunk3nships\n\n"
              " Type [1] for help or something else for play! \n ");
              char c='1';
              printf("%d", c);
       
       scanf("%d", &choice);
        if(choice<=1)
         help();
    
    while(1)
    {
    	draw();
    	if(controls())
    	 return 1;
    	if(ships==0)
       	 {
	      printf("Your game is over! You defate the royal navy and save up %d bottles of beer!\nYeah! :D", beer);
	      printf("\nThanks for playing. :]\n");
	      return 0;
       	 }
    }
}

 
